/*	$Id: genom-hrp2.h 2007/07/03 13:39:31 mallet $ */

/* 
 * Copyright (c) 2007 Anthony Mallet                  --  Thu Jun 21 2007
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
#ifndef H_GENOM_HRP2
#define H_GENOM_HRP2

/* --- Magic numbers ------------------------------------------------- */

#define GHRP2_PLUGIN_PERIOD	(0.005 /*5ms*/)
#define GHRP2_PLUGIN_BUFFER	(1.0 /*seconds of motion*/)


/* --- Robot state --------------------------------------------------- */

/** Joint indexes */
typedef enum ghrp2_joint_index {
  GHRP2_RLEG_JOINT0 = 0,
  GHRP2_RLEG_JOINT1,
  GHRP2_RLEG_JOINT2,
  GHRP2_RLEG_JOINT3,
  GHRP2_RLEG_JOINT4,
  GHRP2_RLEG_JOINT5,

  GHRP2_LLEG_JOINT0,
  GHRP2_LLEG_JOINT1,
  GHRP2_LLEG_JOINT2,
  GHRP2_LLEG_JOINT3,
  GHRP2_LLEG_JOINT4,
  GHRP2_LLEG_JOINT5,

  GHRP2_CHEST_JOINT0,
  GHRP2_CHEST_JOINT1,

  GHRP2_HEAD_JOINT0,
  GHRP2_HEAD_JOINT1,

  GHRP2_RARM_JOINT0,
  GHRP2_RARM_JOINT1,
  GHRP2_RARM_JOINT2,
  GHRP2_RARM_JOINT3,
  GHRP2_RARM_JOINT4,
  GHRP2_RARM_JOINT5,
  GHRP2_RARM_JOINT6,

  GHRP2_LARM_JOINT0,
  GHRP2_LARM_JOINT1,
  GHRP2_LARM_JOINT2,
  GHRP2_LARM_JOINT3,
  GHRP2_LARM_JOINT4,
  GHRP2_LARM_JOINT5,
  GHRP2_LARM_JOINT6,

  GHRP2_RHAND_JOINT0,
  GHRP2_RHAND_JOINT1,
  GHRP2_RHAND_JOINT2,
  GHRP2_RHAND_JOINT3,
  GHRP2_RHAND_JOINT4,

  GHRP2_LHAND_JOINT0,
  GHRP2_LHAND_JOINT1,
  GHRP2_LHAND_JOINT2,
  GHRP2_LHAND_JOINT3,
  GHRP2_LHAND_JOINT4,

  GHRP2_MAXDOF
} ghrp2_joint_index_t;

typedef struct ghrp2_config {
  double time;			/**< current time, or GHRP2_INVAL_TIME */
  double angles[GHRP2_MAXDOF];
  double zmp[3];
  double waistRpy[3];
} ghrp2_config_t;

#endif /* H_GENOM_HRP2 */
